// This class was created by JaTiTV.

package net.t2code.automatedMessages.config;

import net.t2code.automatedMessages.Util;
import net.t2code.automatedMessages.system.Main;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_LanguageWriter;
import net.t2code.t2codelib.util.T2C_ConfigItemLanguages;
import net.t2code.t2codelib.util.T2C_LanguageEnum;

import java.util.HashMap;
import java.util.List;

public class Languages {

    public enum VALUES implements T2C_ConfigItemLanguages {
        otherLang("plugin", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, null);
            put(T2C_LanguageEnum.english, null);
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("Wenn du eine Eigene Sprache hinzufügen magst, dann kopiere einfach eine Sprachdatei und benenne sie in deine Sprache, dies kannst du dann in der config.yml einstellen.", ""));
            put(T2C_LanguageEnum.english, List.of("If you want to add your own language, simply copy a language file and rename it to your language, you can then set this in config.yml.", ""));
        }}),
        msgReloadStart("plugin.reloadStart", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("[prefix] Plugin wird neu geladen..."));
            put(T2C_LanguageEnum.english, List.of("[prefix] Plugin is reloaded..."));
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of("Wenn du eine Eigene Sprache hinzufügen magst, dann kopiere einfach eine Sprachdatei und benenne sie in deine Sprache, dies kannst du dann in der config.yml einstellen.", ""));
            put(T2C_LanguageEnum.english, List.of("If you want to add your own language, simply copy a language file and rename it to your language, you can then set this in config.yml.", ""));
        }}),
        msgReloadEnd("plugin.reloadEnd", null, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),


        ;
        private final String path;
        private Object value;
        private final HashMap<T2C_LanguageEnum, List<String>> lang;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, HashMap<T2C_LanguageEnum, List<String>> lang, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2C_LanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        T2C_LanguageWriter.createConfig(Util.getPrefix(), Main.getPath(), VALUES.values(), Config.VALUES.language.getValue().toString(), isReload, Util.getConfigLogo());
    }
}
