// This class was created by JaTiTV.

package net.t2code.automatedMessages.config;

import lombok.Getter;
import net.t2code.automatedMessages.Util;
import net.t2code.automatedMessages.objects.Message;
import net.t2code.automatedMessages.system.Main;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.Sound;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.List;

public class Messages {

    @Getter
    private static HashMap<String, Message> messageHashMap = new HashMap<>();

    public enum VALUES implements T2C_ConfigItem {
        enable("enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        message("message", "", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        soundEnable("sound.enable", true, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        sound("sound.sound", sound(), true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        interval("permissionNeededToSeeMessage.enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        permissionNeededToSeeMessage("permissionNeededToSeeMessage.permission", "", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        permission("intervalInMin", 0, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        exactTime("exactTime.enable", false, true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        timeMinute("exactTime.timeMinute", "*/5", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        timeHour("exactTime.timeHour", "*", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        timeDayOfMonth("exactTime.timeDayOfMonth", "*", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        timeMonth("exactTime.timeMonth", "*", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        timeDayOfWeek("exactTime.timeDayOfWeek", "*", true, new HashMap<>() {{
            put(T2C_LanguageEnum.german, List.of());
            put(T2C_LanguageEnum.english, List.of());
        }}),
        ;
        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return Config.VALUES.language.getValue().toString();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        messageHashMap.clear();
        File fo = new File(Main.getPath() + "/Messages/");
        File f = new File(Main.getPath() + "/messages/");
        if (!fo.exists()) {
            try {
                Files.move(Paths.get(fo.getAbsolutePath()), Paths.get(f.getAbsolutePath()));
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }

        if (!f.exists()) {
            createDefault("exampleTime.yml", "[prefix] <aqua>Es ist jetzt <yellow>[time]</yellow></aqua>", sound(), 0, "t2c.automatedmessages.messages.exampletime", true, "0/15/30/45");
            createDefault("exampleDiscord.yml", "[prefix] <aqua>If you need help, just contact us on our <color:#ffcb2e><hover:show_text:''<red>dc.t2code.net</red>''><click:open_url:''https://discord.t2code.net''>T2Code Support Discord server</click></hover></color>.</aqua>", sound(), 20, "t2c.automatedmessages.messages.examplediscord", false, "*");
        }

        File[] fileArray = f.listFiles();
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {
                String key = file.getName().replace(".yml", "");
                T2C_ConfigWriter.createConfig(Util.getPrefix(), file, VALUES.values(), false, Util.getConfigLogo());

                Boolean enable = (boolean) VALUES.enable.value;
                String message = VALUES.message.value.toString();
                Boolean soundEnable = (boolean) VALUES.soundEnable.value;

                Sound sound;
                try {
                    sound = Sound.valueOf(VALUES.sound.value.toString());
                } catch (Exception e) {
                    sound = sound();
                }

                Integer interval = (int) VALUES.interval.value;

                Boolean permissionNeededToSeeMessage = (boolean) VALUES.permissionNeededToSeeMessage.value;
                String permission = VALUES.permission.value.toString();

                Boolean exactTime = (boolean) VALUES.exactTime.value;
                String timeMinute = VALUES.timeMinute.value.toString();
                String timeHour = VALUES.timeHour.value.toString();
                String timeDayOfMonth = VALUES.timeDayOfMonth.value.toString();
                String timeMonth = VALUES.timeMonth.value.toString();
                String timeDayOfWeek = VALUES.timeDayOfWeek.value.toString();
                Message msg = new Message(key, enable, message, soundEnable, sound, permissionNeededToSeeMessage, permission, interval,
                        exactTime, timeMinute, timeHour, timeDayOfMonth, timeMonth, timeDayOfWeek);
                messageHashMap.put(key, msg);
            }
        }
    }

    private static void createDefault(String fileName, String message, Sound sound, Integer interval, String permission, Boolean exactTime, String timeMinute) {
        VALUES.enable.setValue(true);
        VALUES.message.setValue(message);
        VALUES.soundEnable.setValue(true);
        VALUES.sound.setValue(sound.toString());
        VALUES.interval.setValue(interval);
        VALUES.permissionNeededToSeeMessage.setValue(false);
        VALUES.permission.setValue(permission);
        VALUES.exactTime.setValue(exactTime);
        VALUES.timeMinute.setValue(timeMinute);
        VALUES.timeHour.setValue("*");
        VALUES.timeDayOfMonth.setValue("*");
        VALUES.timeMonth.setValue("*");
        VALUES.timeDayOfWeek.setValue("*");
        T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath() + "/Messages/" + fileName), VALUES.values(), false, Util.getConfigLogo());
    }

    private static Sound sound() {
        if (T2C_McVersion.isMc1_8()) {
            return Sound.valueOf("NOTE_PIANO");
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            return Sound.valueOf("BLOCK_NOTE_HARP");
        } else return Sound.BLOCK_NOTE_BLOCK_HARP;
    }
}
