package net.t2code.automatedMessages.messages;

import net.t2code.automatedMessages.config.Config;
import net.t2code.automatedMessages.objects.Message;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.text.SimpleDateFormat;
import java.util.*;

public class SendMessage {
    public static void send(Message message) {
        String timeStamp = new SimpleDateFormat(Config.VALUES.timeFormat.getValue().toString()).format(Calendar.getInstance().getTime());
        if ((boolean)Config.VALUES.sendConsole.getValue()) {
            T2C_Send.console(replace(message.message, Map.entry("[time]", timeStamp), Map.entry("[prefix]", Config.VALUES.prefix.getValue().toString())));
        }
        for (Player player : Bukkit.getOnlinePlayers()) {
            if (player.hasPermission(message.permission) || !message.permissionNeededToSeeMessage) {
                T2C_Send.player(player, replace(message.message, Map.entry("[time]", timeStamp), Map.entry("[prefix]", Config.VALUES.prefix.getValue().toString()), Map.entry("[player]", player.getName())));
                player.playSound(player.getLocation(), message.sound, 3, 1);
            }
        }
    }

    @SafeVarargs
    private static Object replace(Object object, Map.Entry<String, String>... map) {
        Object o = null;
        if (object instanceof List) {
            ArrayList<String> res = (ArrayList<String>) object;
            ArrayList<String> out = new ArrayList<>();
            for (String s : res) {
                String re = s;
                for (Map.Entry<String, String> placeholder : map) {
                    re = re.replace(placeholder.getKey(), placeholder.getValue());
                }
                out.add(re);
            }
            o = out;
        }
        if (object instanceof String) {
            String res = (String) object;
            for (Map.Entry<String, String> placeholder : map) {
                res = res.replace(placeholder.getKey(), placeholder.getValue());
            }
          o = res;
        }
        return o;
    }
}
